<?php

chdir(dirname(__FILE__) . '/../');

include_once("./config.php");
include_once("./lib/loader.php");
include_once("./lib/threads.php");

set_time_limit(0);

include_once("./load_settings.php");
include_once(DIR_MODULES . "control_modules/control_modules.class.php");

$ctl = new control_modules();
$checked_time = 0;

echo date("H:i:s") . " running " . basename(__FILE__) . PHP_EOL;

$ip = gg('Mikrotik_IP');
$login = gg('Mikrotik_login');
$password = gg('Mikrotik_password');

// ВНИМАНИЕ на имя класса в вашем файле routeros_api.class.php (в самом начале) 
//$API = new routerosAPI();
$API = new routeros_api();

$sleepErrorTime=60; 

while (1) {
   // штатно
   if ((time()-$checked_time)>10) {
      $checked_time = time();
      setGlobal((str_replace('.php', '', basename(__FILE__))) . 'Run', time(), 1);
   }

   // устанавливаем соединение с микротиком, если оно не создано
   if ($API->connected==0) { 
     if ($API->connect($ip, $login, $password)) { 
       echo 'connect successfully';
       // сброс времени задержки при неудачном соединении 
       $sleepErrorTime=60; 
     } else { 
       echo 'error connected';
       sleep($sleeptime);
       // увеличиваем время следующей попытки соединения вдвое, но не более одного часа
       $sleepErrorTime=min($sleepErrorTime*2, 1*60*60);
       // перейти к следующей итерации
       continue;
     }
   }


/* ******************************************************************** */ 
 // Получить все объекты класса WiFiDevice
 $objects = getObjectsByClass('WiFiDevice'); 

 // При работе в режиме CAPsMAN все клиенты находятся в таблице /caps-man/registration-table/print
 $ARRAY = $API->comm('/caps-man/registration-table/print');
  
 // перебор объектов класса WiFiDevice
 foreach ($objects as $obj) {
  $obj=getObject($obj['TITLE']);
  $f=0;
  
  // перебор массива роутера 
  foreach ($ARRAY as $i => $arr) {
   if ($obj->getProperty('MAC') == $arr['mac-address']) {
    //$obj->setProperty('lastActive' , date("Y-m-d H:i:s",time()));
    
    // Вызоы метода CAPchange, если предыдущая точка была другая, небыло вовсе,
    // и устройство было online.
    // Этот метод будет вызван первым. Ранее  Found и Located
    if ($obj->getProperty('CAPname') != $arr['interface']) {
     // ToThink Имя старой точки можно передавать параметром через метод CAPchange.
     //         Тогда в методе будет возможность увидеть имя старой и новой точки.
     //         может быть полезным при реализации условия перехода именно с конкретной точки на нужную
     $oldCAPName = $obj->getProperty('CAPname');
     $obj->setProperty('CAPname', $arr['interface']);
     if ($obj->getProperty('online')) {
      $obj->callMethod('CAPchange', array('oldCAPName' => $oldCAPName));  //ToTest
     }
     unset($oldCapName);
    }

    // Вызов метода Found если устройство не было onLine
    // В данный момент точка доступа в объекте уже записана новая
    if (!$obj->getProperty('online')) {
     $j=$obj->getProperty('holdCycles');
     if (!$j) { $j=1; }
     $obj->setProperty('online', $j); 
     unset($j);
     $obj->callMethod('Found');
    }
    
    // Вызов метода Located каждый раз при опросе и присутствии девайса в сети
    // будет использоваться например для продления активности в комнате
    // в данный момент в объекте записана новыя точка доступа
    $obj->callMethod('Located');
    $obj->setProperty('lastActive' , date("Y-m-d H:i:s",time()));
    
    // удаляем элемент массива
    unset($ARRAY[$i]);
    $f=1;
    // break; 
   }
  }
 
  // если MAC этого объекта в массиве роутера нет
  // Уменьшить свойство online. Когда достигнет нуля, вызвать метод Lost
  if (!$f) {
   $j=$obj->getProperty('online');
   if ($j) {
    $j=$j-1;
    $obj->setProperty('online', $j); 
    // Вызов метода Lost
    if (!$j) { $obj->callMethod('Lost'); }
   }
   unset($j);
  } 
 
 }

 
 // перебор оставщихся MAC адресов массива роутера
 foreach ($ARRAY as $arr) {
  // Создание нового объекта
  say('Зарегистрировано новое ВайФай устройство.');
  addClassObject('WiFiDevice', 'wifi_'.$arr['mac-address']);
  $obj=getObject('wifi_'.$arr['mac-address']);
  $obj->setProperty('MAC', $arr['mac-address']); 
  $obj->setProperty('CAPname', $arr['interface']);
  //$obj->setProperty('name', 'Неизвестный девайс'); 
  $obj->setProperty('lastActive' , date("Y-m-d H:i:s",time()));
  $obj->setProperty('notify' , '20');
  $obj->setProperty('online', '1');
  $obj->setProperty('holdCycles', '2'); 
  $obj->callMethod('Found');
 } 

 
/* ******************************************************************** */ 
 // Получить все объекты класса WiFi точек доступа
 $objects = getObjectsByClass('WiFiCaps'); 

 // таблица роутера с точками доступа
 $ARRAY = $API->comm('/caps-man/interface/print');

 // перебор объектов класса WiFiCaps
 foreach ($objects as $obj) {
  $obj=getObject($obj['TITLE']);
  
  // перебор массива роутера 
  foreach ($ARRAY as $i => $arr) {
   if ($obj->object_title == $arr['name']) {
    
    if ($obj->getProperty('MAC') != $arr['mac-address']) {
     $obj->setProperty('MAC', $arr['mac-address']);
    }

    // Основной показатель работоспособности точки
    // свидетельствует о наличии линка у точки с главным
    if ($obj->getProperty('bound') != $arr['bound']) {
     $obj->setProperty('bound', $arr['bound']);
     // Вызов метода
     if ($arr['bound']=='true') {
      $obj->callMethod('Found');
     } else {
      $obj->callMethod('Lost');
     }
    }

    if ($obj->getProperty('inactive') != $arr['inactive']) {
     $obj->setProperty('inactive', $arr['inactive']);
     //$obj->callMethod('');
    }

    if ($obj->getProperty('running') != $arr['running']) {
     $obj->setProperty('running', $arr['running']);
     //$obj->callMethod('');
    }

    if ($obj->getProperty('disabled') != $arr['disabled']) {
     $obj->setProperty('disabled', $arr['disabled']);
     //$obj->callMethod('');
    }

    // удаляем элемент массива
    unset($ARRAY[$i]);

   } // имена равны
  } // массив роутера
 } // объекты класса

 
 // перебор оставщихся элементов массива роутера
 foreach ($ARRAY as $arr) {
  // Создание нового объекта
  say('Зарегистрирована новая точка доступа '.$arr['name']);
  addClassObject('WiFiCaps', $arr['name']);
  $obj=getObject($arr['name']);
  $obj->setProperty('MAC', $arr['mac-address']); 
  $obj->setProperty('bound', $arr['bound']); 
  $obj->setProperty('inactive', $arr['inactive']); 
  $obj->setProperty('running', $arr['running']); 
  $obj->setProperty('disabled', $arr['disabled']); 
  // $obj->callMethod('Found');
 }

/* ******************************************************************** */ 
 // Контроль состояния провайдеров
 // 0-нет линка 1-линк с провайдером 2-есть Интернет 3-выбран основным
 $isp1=0; $isp2=0;
 // пинг до микротиковского облака
 $isp1png=''; $isp2png='';

 // Узнаем о наличии линка и Интернета за провайдером с помощью Detect Internet
 // ВНИМАНИЕ замените имена интерфейсов на свои
 $ARRAY = $API->comm('/interface/detect-internet/state/print');
 // перебор массива роутера 
 foreach ($ARRAY as $i => $arr) {
  switch ($arr['state']) {
   // Интернет за провайдером
   case 'internet':
    if ($arr['name']=='pppoe-out1') { $isp1=2; $isp1png=$arr['cloud-rtt']; }
    if ($arr['name']=='lte1') { $isp2=2; $isp2png=$arr['cloud-rtt']; }
    break;
   // провайдер доступен
   case 'wan':
   case 'lan':
    if ($arr['name']=='pppoe-out1') { $isp1=1; }
    if ($arr['name']=='lte1') { $isp2=1; }
    break;
   // нет линка с провайдером
   case 'no-link':
   default: 
    if ($arr['name']=='pppoe-out1') { $isp1=0; }
    if ($arr['name']=='lte1') { $isp2=0; }
 }}
 // пинги до м.облока
 sg('isp1ping',$isp1png);
 sg('isp2ping',$isp2png);

 
 // таблица роутера ip route print detail
 $ARRAY = $API->comm('/ip/route/print');
 // перебор массива роутера в поисках основного провайдера
 // ВНИМАНИЕ замените id *1D и *1E на свои
 // при желании id записей можно заменить на уникальные комментарии,
 // и в switch использовать $arr['comment']
 foreach ($ARRAY as $i => $arr) {
  if ($arr['active']=='true') {
   switch ($arr['.id']) {
    case '*1D':
     $isp1=max($isp1,3);
     break;
    case '*1E':
     $isp2=max($isp2,3);
     break;
 }}}    

 
 $pisp=gg('isp1');
 $isp=$isp1;
 $t='';
 if ($pisp<>$isp) {
  $p='Ростелеком';
  if ($isp==0) {$t="Потеря соединения c провайдером $p";}
  elseif ($isp==1 && $pisp==0) {$t="Установлено соединения c провайдером $p";}
  elseif ($isp==1 && $pisp>=2) {$t="Провайдер $p не предоставляет Интернет";}
  elseif ($isp==2 && $pisp<=1) {$t="Провайдер $p, Интернет предоставлен";}
  elseif ($isp==3) {$t="Провайдер $p выбран основным";}
  sg('isp1',$isp1);
  if ($t) { say($t); }
 }

 $pisp=gg('isp2');
 $isp=$isp2;
 $t='';
 if ($pisp<>$isp) {
  $p='Бинайн';
  if ($isp==0) {$t="Потеря соединения c провайдером $p";}
  elseif ($isp==1 && $pisp==0) {$t="Установлено соединения c провайдером $p";}
  elseif ($isp==1 && $pisp>=2) {$t="Провайдер $p не предоставляет Интернет";}
  elseif ($isp==2 && $pisp<=1) {$t="Провайдер $p, Интернет предоставлен";}
  elseif ($isp==3) {$t="Провайдер $p выбран основным";}
  sg('isp2',$isp2);
  if ($t) { say($t); }
 }

/* ******************************************************************** */ 
 


   // штатно
   if (file_exists('./reboot') || IsSet($_GET['onetime'])) {
      // завершить соединение с микротиком
      $API->disconnect();
      exit;
   }
   sleep(10);
}

DebMes("Unexpected close of cycle: " . basename(__FILE__));
